#include <stdio.h>
#include <math.h>
#include <iostream>

using namespace std;

static int a[2000001];
static int c[1000000];

int main()
{
    int n,k,i,z=0,b;
    scanf("%d%d",&n,&k);
    for(i=0;i<n;i++)
    {
        scanf("%d",&b);
        a[b+n]++;
        if(a[b+n]==k){c[z++]=b;a[b+n]=INT_MIN;}
    }
    printf("%d\n",z);
    for(i=0;i<z;i++)
    {
        printf("%d ",c[i]);
    }
}